using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;



namespace Project
{    
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        public int SND_ASYNC = 0x0001;
        public int SND_NODEFAULT = 0x0002;
        public int SND_LOOP = 0x0008;
        public int SND_FILENAME = 0x00020000;
        
        [DllImport("winmm.dll")]
        private static extern bool PlaySound(string lpszName, int hModule, int dwFlags); 
               
        private void ErrorMessages()
        {

            int nVaxObjectError = VaxSIPUserAgentOCX.GetVaxObjectError();

            switch (nVaxObjectError)
            {
                case 10:
                    MessageBox.Show("You are not Online, please click the 'Online' button first.");
                    break;

                case 11:
                    MessageBox.Show("Cann't open local communication port. Another softphone (x-Ten, x-lite or skype etc) is already running. Please close it first.");
                    break;

                case 12:
                    MessageBox.Show("License Key is not valid.");
                    break;

                case 13:
                    MessageBox.Show("Fail to initialize VaxVoIP task window.");
                    break;

                case 14:
                    MessageBox.Show("Cann't access Input/Mic device or device is already in use.");
                    break;

                case 15:
                    MessageBox.Show("Cann't access Output/Speaker device or device is already in use.");
                    break;

                case 16:
                    MessageBox.Show("Input/Mic device is not open.");
                    break;

                case 17:
                    MessageBox.Show("Output/Speaker device is not open.");
                    break;

                case 18:
                    MessageBox.Show("Your sound device does not support mic volume.");
                    break;

                case 19:
                    MessageBox.Show("Your sound device does not support speaker volume.");
                    break;

                case 20:
                    MessageBox.Show("Recording media initialization fail.");
                    break;

                case 21:
                    MessageBox.Show("Cann't open the wave file.");
                    break;

                case 22:
                    MessageBox.Show("Provided SIP URI is not valid.");
                    break;

                case 23:
                    MessageBox.Show("Codec is not supported.");
                    break;

                case 24:
                    MessageBox.Show("Error to create SDP (Session Description Protocol) request.");
                    break;

                case 25:
                    MessageBox.Show("Error to create CONNECTION request. Please check the provided SIP URI is valid.");
                    break;

                case 26:
                    MessageBox.Show("Error to create REGISTER request. Please check the provided SIP URI is valid.");
                    break;

                case 27:
                    MessageBox.Show("Error to create UN-REGISTER request. Please check the provided SIP URI is valid.");
                    break;

                case 28:
                    MessageBox.Show("Error to create DISCONNECT request.");
                    break;

                case 29:
                    MessageBox.Show("Line No is not valid.");
                    break;

                case 30:
                    MessageBox.Show("Line is already busy.");
                    break;

                case 31:
                    MessageBox.Show("Line is not open.");
                    break;

                case 32:
                    MessageBox.Show("Invalid Call-Id.");
                    break;

                case 33:
                    MessageBox.Show("Provided value is not valid.");
                    break;

                case 34:
                    MessageBox.Show("Selected line is not in voice session.");
                    break;

                case 35:
                    MessageBox.Show("Fail to read wave file.");
                    break;

                case 36:
                    MessageBox.Show("Fail to write wave file.");
                    break;

                case 37:
                    MessageBox.Show("Unsupported wave file format.");
                    break;
            }

        }
        
        private void FillComboBox(int nTotalLine)
        {
            ComboDial.Items.Clear();
            ComboRecord.Items.Clear();
            ComboPlayWave.Items.Clear();
            ComboIncomingCall.Items.Clear();
            ComboTransferCall.Items.Clear();

            for(int nLineNo = 1; nLineNo <= nTotalLine; nLineNo++)
            {
                ComboDial.Items.Add("Line-" + Convert.ToString(nLineNo));
                ComboRecord.Items.Add("Line-" + Convert.ToString(nLineNo));
                ComboPlayWave.Items.Add("Line-" + Convert.ToString(nLineNo));
                ComboIncomingCall.Items.Add("Line-" + Convert.ToString(nLineNo));
                ComboTransferCall.Items.Add("Line-" + Convert.ToString(nLineNo));
            }
                    
            ComboDial.SelectedIndex = 0;
            ComboRecord.SelectedIndex = 0;
            ComboPlayWave.SelectedIndex = 0;
            ComboIncomingCall.SelectedIndex = 0;
            ComboTransferCall.SelectedIndex = 0;

        }
        
        private Boolean InitVaxVoIPObject()
        {
            /********************************************************************
                    Listen Port: default SIP port 5060.
                      SIP Proxy: SIP Proxy IP or FQDN provided by your service provider.
                  OutboundProxy: SIP outbound/NAT proxy IP or FQDN provided by your
                    service provider to use SIP phone behind the NAT.
        
            *********************************************************************/
            
            /****** Constructing SIP From URI for IP Telephony *******/
            string sFromURI = EditLoginId.Text + " <sip:" + EditLoginId.Text + "@" + EditSIPProxy.Text + ">";

            if(EditDisplayName.Text != "")
                sFromURI = EditDisplayName.Text + " <sip:" + EditLoginId.Text + "@" + EditSIPProxy.Text + ">";

            String sMyIP = VaxSIPUserAgentOCX.GetMyIP();
            Boolean bResult = true;

            int nListenPort = 5060;

            for(nListenPort = 5060; nListenPort < 7000; nListenPort++)
            {
                if (!VaxSIPUserAgentOCX.Initialize(false, sMyIP, nListenPort, sFromURI, EditOutBoundProxy.Text, EditSIPProxy.Text, EditLoginId.Text, EditLoginPwd.Text, CheckEnableSoundDevice.Checked, Convert.ToInt32(EditTotalLines.Text)))
                {
                    if(11 != VaxSIPUserAgentOCX.GetVaxObjectError())
                    {
                        bResult = false;
                        
                        ErrorMessages();
                        break;
                    }
                }
                else
                {
                    break;
                }
            }

            if(nListenPort >= 7000)
            {
                MessageBox.Show("Cann't open SIP communication port.");
                bResult = false;
            }

            return bResult;
        }

        private Boolean OpenLines(int nTotalNoOfLine)
        {
            Boolean bResult = true;
            int nListenPort = 7000;
            int nErrorCount = 0;

            String sMyIP = VaxSIPUserAgentOCX.GetMyIP();

            for (int nLineNo = 0; nLineNo < nTotalNoOfLine; nLineNo++)
            {
                if (!VaxSIPUserAgentOCX.OpenLine(nLineNo, false, sMyIP, nListenPort))
                {
                    if (VaxSIPUserAgentOCX.GetVaxObjectError() != 11)
                    {
                        bResult = false;

                        ErrorMessages();
                        break;
                    }
                    else
                    {
                        nErrorCount += 1;
                        nLineNo = nLineNo - 1;
                    }

                }

                nListenPort += 2; //It is importent to increament RTP Listen port by 2

                if (nErrorCount >= (nTotalNoOfLine + 1000)) // If unable to open more than 1000 ports.
                {
                    MessageBox.Show("Unable to open RTP communication port.");
                    bResult = false;
                    break;
                }
            }

            return bResult;
        }

        private void BtnOnline_Click(object sender, EventArgs e)
        {
            if( BtnOnline.Text == "Offline")
            {
                VaxSIPUserAgentOCX.UnInitialize();

                BtnOnline.Text = "Online";
                EditTotalLines.Enabled = true;

                ListViewLineStatus.Items.Clear();
                ListAudioOut.Items.Clear();
                ListAudioIn.Items.Clear();
                
                TimerTick.Enabled = false;
                ProgressTimer.Enabled = false;
                
                SpkProgBar.Value = 0;
                MicProgBar.Value = 0;

                return;
            }
                        
            if( EditLoginId.Text == "")
            {
                MessageBox.Show("Please enter the SIP proxy Login Id.");
                return;
            }

            if( EditSIPProxy.Text == "" )
            {
                MessageBox.Show("Please enter the SIP proxy address or URI.");
                return;
            }

            VaxSIPUserAgentOCX.SetLicenceKey("TRIAL-LICENSE-KEY");
                                
            if(!InitVaxVoIPObject())
                return;
            
            if(!OpenLines(Convert.ToInt32(EditTotalLines.Text)))
                return;

            if (CheckRegisterToProxy.Checked)
            {
                if (!VaxSIPUserAgentOCX.RegisterToProxy(3600))
                {
                    ErrorMessages();
                    return;
                }

                AddToStatusLog("Registering to SIP Proxy.");
            }

            CheckEchoCancel.Checked = true;
            CheckGSM610.Checked = true;
            CheckiLBC.Checked = true;
            CheckG711A.Checked = true;
            CheckG711U.Checked = true;

            VaxSIPUserAgentOCX.EnableKeepAlive(10);
                        
            BtnOnline.Text = "Offline";
            EditTotalLines.Enabled = false;
            
            TimerTick.Enabled = true;
            ProgressTimer.Enabled = true;

            FillComboBox(Convert.ToInt32(EditTotalLines.Text));
            
            UpdateAudioOut();
            UpdateAudioIn();
        }

        private void UpdateAudioIn()
        {
            ListAudioIn.Items.Clear();
            ListAudioIn.Items.Add("Default Device");

            for(int nDeviceId = 0; nDeviceId < VaxSIPUserAgentOCX.GetAudioInDevTotal(); nDeviceId++)
            {
                ListAudioIn.Items.Add(VaxSIPUserAgentOCX.GetAudioInDevName(nDeviceId));
            }
            
            ListAudioIn.SelectedIndex = 0;
        }

        private void UpdateAudioOut()
        {
            ListAudioOut.Items.Clear();
            ListAudioOut.Items.Add("Default Device");

            for (int nDeviceId = 0; nDeviceId < VaxSIPUserAgentOCX.GetAudioOutDevTotal(); nDeviceId++)
            {
                ListAudioOut.Items.Add(VaxSIPUserAgentOCX.GetAudioOutDevName(nDeviceId));
            }

            ListAudioOut.SelectedIndex = 0;
        }
        
        private void BtnDialPad1_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "1";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "1");
        }

        private void BtnDialPad2_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "2";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "2");
        }

        private void BtnDialPad3_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "3";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "3");
        }

        private void BtnDialPad4_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "4";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "4");
        }

        private void BtnDialPad5_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "5";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "5");
        }

        private void BtnDialPad6_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "6";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "6");
        }

        private void BtnDialPad7_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "7";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "7");
        }

        private void BtnDialPad8_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "8";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "8");
        }

        private void BtnDialPad9_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "9";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "9");
        }

        private void BtnDialPadStar_Click(object sender, EventArgs e)
        {
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "*");
        }

        private void BtnDialPad0_Click(object sender, EventArgs e)
        {
            EditPhoneNo.Text += "0";
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "0");
        }

        private void BtnDialPadNo_Click(object sender, EventArgs e)
        {
            VaxSIPUserAgentOCX.DigitDTMF(ComboDial.SelectedIndex, "#");
        }

        private void BtnDial_Click(object sender, EventArgs e)
        {
           if( EditPhoneNo.Text == "" )
           {
                MessageBox.Show("Please enter a phone number.");
               return;
           }    
        
            /*******************************************************
                Constructing SIP To URI for IP Telephony:
                       sip:PhoneNumber@SIP Proxy
            ********************************************************/

            String sToURI = "sip:" + EditPhoneNo.Text + "@" + EditSIPProxy.Text;

            int nLineNo = ComboDial.SelectedIndex;

            if (!VaxSIPUserAgentOCX.Connect(nLineNo, sToURI, ListAudioIn.SelectedIndex - 1, ListAudioOut.SelectedIndex - 1))
            {
                ErrorMessages();
            }
            else
            {
                AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Dialing.");
            }
        }

        private void BtnHangUp_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.Disconnect(ComboDial.SelectedIndex))
                ErrorMessages();
        }

        private void BtnHold_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.HoldLine(ComboDial.SelectedIndex))
                ErrorMessages();
        }

        private void BtnUnHold_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.UnHoldLine(ComboDial.SelectedIndex))
                ErrorMessages();
        }
                
        private void BtnAccept_Click(object sender, EventArgs e)
        {
            int nSelectedItemIndex = ListIncomingCall.SelectedIndex;
            if(nSelectedItemIndex == -1)
                return;

            String sCallId = ListIncomingCallIds.Items[nSelectedItemIndex].ToString();
            int nLineNo = ComboIncomingCall.SelectedIndex;

            if (!VaxSIPUserAgentOCX.AcceptCall(nLineNo, sCallId, ListAudioIn.SelectedIndex - 1, ListAudioOut.SelectedIndex - 1))
            {
                ErrorMessages();
                return;
            }
        
            PlaySound(null, 0, 0);

            ListIncomingCall.Items.RemoveAt(nSelectedItemIndex);
            ListIncomingCallIds.Items.RemoveAt(nSelectedItemIndex);

            if ((ListIncomingCall.SelectedIndex == -1) && (ListIncomingCall.Items.Count > 0))
            {
                ListIncomingCall.SelectedIndex = 0;
            }
        }

        private void BtnReject_Click(object sender, EventArgs e)
        {
            int nSelectedItemIndex = ListIncomingCall.SelectedIndex;
            if(nSelectedItemIndex == -1)
                return;
        
            String sCallId = ListIncomingCallIds.Items[nSelectedItemIndex].ToString();

            if(!VaxSIPUserAgentOCX.RejectCall(sCallId))
                ErrorMessages();

            PlaySound(null, 0, 0);

            ListIncomingCall.Items.RemoveAt(nSelectedItemIndex);
            ListIncomingCallIds.Items.RemoveAt(nSelectedItemIndex);

            if ((ListIncomingCall.SelectedIndex == -1) && (ListIncomingCall.Items.Count > 0))
            {
                ListIncomingCall.SelectedIndex = 0;
            }
        }

        private void CheckPlayRingTone_CheckedChanged(object sender, EventArgs e)
        {
            if(CheckPlayRingTone.Checked == false)
            {
                PlaySound(null, 0, 0);
            }
        }

        private void CheckkStartRecording_CheckedChanged(object sender, EventArgs e)
        {
           int nLineNo = ComboRecord.SelectedIndex;
           if(CheckkStartRecording.Checked == true)
           {
               if(!VaxSIPUserAgentOCX.StartRecording(nLineNo, 2, true))
                   ErrorMessages();
           }
           else
           {
               VaxSIPUserAgentOCX.StopRecording(nLineNo);
           }
        }

        private void BtnResetRecordingBuffer_Click(object sender, EventArgs e)
        {
            VaxSIPUserAgentOCX.ResetRecording(ComboRecord.SelectedIndex);
        }

        private void BtnSaveToWaveFile_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.SaveRecordingToWaveFile(ComboRecord.SelectedIndex, EditSaveFileName.Text))
                ErrorMessages();
            else
                MessageBox.Show("Saved Successfully");
        }

        private void BtnSetPlayFile_Click(object sender, EventArgs e)
        {
            if(!VaxSIPUserAgentOCX.PlayWaveOpen(ComboPlayWave.SelectedIndex, EditPlayFileName.Text))
                ErrorMessages();
        }

        private void BtnStartPlay_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.PlayWaveStart(ComboPlayWave.SelectedIndex, CheckPlayListen.Checked))
                ErrorMessages();
        }

        private void BtnPlayRewind_Click(object sender, EventArgs e)
        {
            if(!VaxSIPUserAgentOCX.PlayWaveSkipTo(ComboPlayWave.SelectedIndex, VaxSIPUserAgentOCX.PlayWavePosition(ComboPlayWave.SelectedIndex) - 2))
                ErrorMessages();
        }

        private void BtnPlayForward_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.PlayWaveSkipTo(ComboPlayWave.SelectedIndex, VaxSIPUserAgentOCX.PlayWavePosition(ComboPlayWave.SelectedIndex) + 2))
                ErrorMessages();
        }

        private void BtnPlayPause_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.PlayWavePause(ComboPlayWave.SelectedIndex))
                ErrorMessages();
        }

        private void BtnPlayStop_Click(object sender, EventArgs e)
        {
            if (!VaxSIPUserAgentOCX.PlayWaveStop(ComboPlayWave.SelectedIndex))
                ErrorMessages();
        }

        private void SliderSpkVol_Scroll(object sender, EventArgs e)
        {
            /*
            SetSpkVolume method requires Volume value from 0 to 255 range    
            but the slider range is 0 to 10, so we multiply the slider value 
            to 25 to get the required value to pass to SetSpkVolume method.
            */

            VaxSIPUserAgentOCX.SetSpkVolume(SliderSpkVol.Value * 25);
        }

        private void SliderMicVol_Scroll(object sender, EventArgs e)
        {
            /*
            SetMicVolume method requires Volume value from 0 to 255 range    
            but the slider range is 0 to 10, so we multiply the slider value 
            to 25 to get the required value to pass to SetMicVolume method.
            */

            VaxSIPUserAgentOCX.SetMicVolume(SliderMicVol.Value * 25);
        }

        private void CheckSpkMute_CheckedChanged(object sender, EventArgs e)
        {
            VaxSIPUserAgentOCX.MuteSpk(CheckSpkMute.Checked);
        }

        private void CheckMuteMic_CheckedChanged(object sender, EventArgs e)
        {
            VaxSIPUserAgentOCX.MuteMic(CheckMuteMic.Checked);
        }

        private void CheckEchoCancel_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckEchoCancel.Checked == true)
                VaxSIPUserAgentOCX.EnableEchoNoiseCancellation();
            else
                VaxSIPUserAgentOCX.DisableEchoNoiseCancellation();
        }

        private void CheckAGC_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckAGC.Checked == true)
            {
                if (VaxSIPUserAgentOCX.EnableAGC(8000))
                    ErrorMessages();
            }
            else
            {
                VaxSIPUserAgentOCX.DisableAGC();
            }
        }

        private void CheckMicBoost_CheckedChanged(object sender, EventArgs e)
        {
            if(CheckMicBoost.Checked == true)
                VaxSIPUserAgentOCX.EnableMicBoost();
            else
                VaxSIPUserAgentOCX.DisableMicBoost();
        }

        private void CheckDisturb_CheckedChanged(object sender, EventArgs e)
        {
            if(CheckDisturb.Checked == true)
                VaxSIPUserAgentOCX.EnableDonotDisturb();
            else
                VaxSIPUserAgentOCX.DisableDonotDisturb();
        }

        private void CheckGSM610_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 0 represents GSM 6.10 *****/

            if (CheckGSM610.Checked == true)
                VaxSIPUserAgentOCX.SelectVoiceCodec(0);
            else
                VaxSIPUserAgentOCX.DeselectVoiceCodec(0);
        }

        private void CheckiLBC_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 1 represents iLBC *****/

            if (CheckiLBC.Checked == true)
                VaxSIPUserAgentOCX.SelectVoiceCodec(1);
            else
                VaxSIPUserAgentOCX.DeselectVoiceCodec(1);
            
        }

        private void CheckG711A_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 2 represents G711 A-LAW *****/

            if(CheckG711A.Checked == true)
                VaxSIPUserAgentOCX.SelectVoiceCodec(2);
            else
                VaxSIPUserAgentOCX.DeselectVoiceCodec(2);
        }

        private void CheckG711U_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 3 represents G711 U-LAW *****/

            if (CheckG711U.Checked == true)
                VaxSIPUserAgentOCX.SelectVoiceCodec(3);
            else
                VaxSIPUserAgentOCX.DeselectVoiceCodec(3);
        }

        private void BtnTransferCall_Click(object sender, EventArgs e)
        {
            String sToURI = "sip:" + EditTransferPhoneNo.Text + "@" + EditSIPProxy.Text;
        
            if(!VaxSIPUserAgentOCX.TransferCall(ComboTransferCall.SelectedIndex, sToURI))
                ErrorMessages();
        }

        private void BtnClearLog_Click(object sender, EventArgs e)
        {
            ListStatusLog.Items.Clear();
        }

        private void VaxSIPUserAgentOCX_OnCallTransferAccepted(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnCallTransferAcceptedEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Transfer accepted.");
        }

        private void VaxSIPUserAgentOCX_OnConnecting(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnConnectingEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Connecting.");
        }

        private void VaxSIPUserAgentOCX_OnDisconnectCall(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnDisconnectCallEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Hung up.");
        }

        private void VaxSIPUserAgentOCX_OnFailToConnect(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnFailToConnectEvent e)
        {
             AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Fail to connect.");
        }
        
        private void VaxSIPUserAgentOCX_OnFailToRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Fail to register.");
        }
                
        private void VaxSIPUserAgentOCX_OnFailToUnRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Fail to unregister.");
        }

        private void VaxSIPUserAgentOCX_OnGeneralFailureResponse(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnGeneralFailureResponseEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + " Response: " + e.reasonPhrase);
        }

        private void VaxSIPUserAgentOCX_OnIncomingCall(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallEvent e)
        {
            if(ListIncomingCallIds.FindString(e.callId) == -1)
                ListIncomingCallIds.Items.Add(e.callId);

            if(e.displayName.Length != 0)
                ListIncomingCall.Items.Add("CLI: " + e.displayName);
            else
                ListIncomingCall.Items.Add("CLI: " + e.userName);

            if((ListIncomingCall.SelectedIndex == -1) && (ListIncomingCall.Items.Count > 0))
                ListIncomingCall.SelectedIndex = 0;
            
        }

        private void VaxSIPUserAgentOCX_OnIncomingCallRingingStart(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallRingingStartEvent e)
        {
            if(CheckPlayRingTone.Checked == true)
                PlaySound("ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
        }

        private void VaxSIPUserAgentOCX_OnIncomingCallRingingStop(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallRingingStopEvent e)
        {
            int nItemIndex = ListIncomingCallIds.Items.IndexOf(e.callId);
            if (nItemIndex == -1) return;

            ListIncomingCallIds.Items.RemoveAt(nItemIndex);
            ListIncomingCall.Items.RemoveAt(nItemIndex);
            
            PlaySound(null, 0, 0);
        }

        private void VaxSIPUserAgentOCX_OnPlayWaveDone(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnPlayWaveDoneEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Play wave done.");
        }

        private void VaxSIPUserAgentOCX_OnProvisionalResponse(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnProvisionalResponseEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo+ 1) + ": Response: " + e.reasonPhrase);
        }

        private void VaxSIPUserAgentOCX_OnRedirectionResponse(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnRedirectionResponseEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Response: " + e.reasonPhrase);
        }

        private void VaxSIPUserAgentOCX_OnRequestFailureResponse(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnRequestFailureResponseEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Response: " + e.reasonPhrase);
        }

        private void VaxSIPUserAgentOCX_OnServerFailureResponse(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnServerFailureResponseEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Response: " + e.reasonPhrase);
        }

        private void VaxSIPUserAgentOCX_OnSuccessToConnect(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnSuccessToConnectEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Success to connect.");

            int nVol = VaxSIPUserAgentOCX.GetSpkVolume();
            SliderSpkVol.Value = nVol / 25;

            nVol = VaxSIPUserAgentOCX.GetMicVolume();
            SliderMicVol.Value = nVol / 25;

            CheckMicBoost.Checked = VaxSIPUserAgentOCX.IsMicBoostEnable();

        }
                
        private void VaxSIPUserAgentOCX_OnSuccessToRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Registered successfully.");
        }

        private void VaxSIPUserAgentOCX_OnSuccessToUnRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Unregistered successfully.");
        }
        
        private void VaxSIPUserAgentOCX_OnTryingToRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Trying to register.");
        }

        private void VaxSIPUserAgentOCX_OnTryingToUnRegister(object sender, EventArgs e)
        {
            AddToStatusLog("Trying to Unregister.");
        }

        private String CodecName(int nCodecNo)
        {
            if (nCodecNo == 0)
                return "gsm6.10";

            if (nCodecNo == 1)
                return "iLBC";

            if (nCodecNo == 2)
                return "gsm711a";

            if (nCodecNo == 3)
                return "gsm711u";

            return "";
        }

        private void TimerTick_Tick(object sender, EventArgs e)
        {
            if (ListViewLineStatus.Items.Count == 0)
            {
                for (int nLineNo = 0; nLineNo < Convert.ToInt32(EditTotalLines.Text); nLineNo++)
                {
                    ListViewItem ItemLineNo = new ListViewItem();
                    ItemLineNo.Text = Convert.ToString(nLineNo + 1);
                    ListViewLineStatus.Items.Add(ItemLineNo);

                    for (int nSubItem = 0; nSubItem < 3; nSubItem++)
                    {
                        ListViewItem.ListViewSubItem SubItemStatus = new ListViewItem.ListViewSubItem();
                        ItemLineNo.SubItems.Add(SubItemStatus);
                    }
                }
            }
                                   
            for (int nLineNo = 0; nLineNo < Convert.ToInt32(EditTotalLines.Text); nLineNo++)
            {
                ListViewLineStatus.Items[nLineNo].SubItems[2].Text = CodecName(VaxSIPUserAgentOCX.GetOutboundCodec(nLineNo));
                ListViewLineStatus.Items[nLineNo].SubItems[3].Text = CodecName(VaxSIPUserAgentOCX.GetInboundCodec(nLineNo));
                                
                String sItemText = ListViewLineStatus.Items[nLineNo].Text;
                
                if (VaxSIPUserAgentOCX.IsLineOpen(nLineNo) == false)
                {
                    if (sItemText.IndexOf("close") == -1)
                        ListViewLineStatus.Items[nLineNo].SubItems[1].Text = "close";
                }
                else
                {
                    if (VaxSIPUserAgentOCX.IsLineBusy(nLineNo) == true)
                    {
                        if (VaxSIPUserAgentOCX.IsWaveFilePlaying(nLineNo) == true)
                        {
                            if (sItemText.IndexOf("playing") == -1)
                                ListViewLineStatus.Items[nLineNo].SubItems[1].Text = "playing";
                        }
                        else
                        {
                            if (VaxSIPUserAgentOCX.IsLineHold(nLineNo) == true)
                            {
                                if (sItemText.IndexOf("hold") == -1)
                                    ListViewLineStatus.Items[nLineNo].SubItems[1].Text = "hold";
                            }
                            else
                            {
                                if (sItemText.IndexOf("busy") == -1)
                                    ListViewLineStatus.Items[nLineNo].SubItems[1].Text = "busy";
                            }
                        }
                    }
                    else
                    {
                        if (sItemText.IndexOf("free") == -1)
                            ListViewLineStatus.Items[nLineNo].SubItems[1].Text = "free";
                    }
                }
            }
        }

        private void ComboRecord_SelectedIndexChanged(object sender, EventArgs e)
        {
            CheckkStartRecording.Checked = VaxSIPUserAgentOCX.IsRecording(ComboRecord.SelectedIndex);
        }

        private void BtnHelpMore_Click(object sender, EventArgs e)
        {
            HelpForm HelpDlg = new HelpForm();
            HelpDlg.ShowDialog();
        }

        private void VaxSIPUserAgentOCX_OnDTMFDigit(object sender, AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnDTMFDigitEvent e)
        {
            AddToStatusLog("Line-" + Convert.ToString(e.lineNo + 1) + ": Key-pressed: " + e.digit);
        }

        private void AddToStatusLog(String sStatusLog)
        {
            ListStatusLog.Items.Add(sStatusLog);
            ListStatusLog.TopIndex = ListStatusLog.Items.Count - 1;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            ColumnHeader ColumnNo = new ColumnHeader();
            ColumnNo.Text = "#";
            ColumnNo.Width = 24;
            ListViewLineStatus.Columns.Add(ColumnNo);

            ColumnHeader ColumnStatus = new ColumnHeader();
            ColumnStatus.Text = "Status";
            ColumnStatus.Width = 55;
            ListViewLineStatus.Columns.Add(ColumnStatus);

            ColumnHeader ColumnOutbound = new ColumnHeader();
            ColumnOutbound.Text = "Outbound";
            ColumnOutbound.Width = 70;
            ListViewLineStatus.Columns.Add(ColumnOutbound);

            ColumnHeader ColumnInbound = new ColumnHeader();
            ColumnInbound.Text = "Inbound";
            ColumnInbound.Width = 65;
            ListViewLineStatus.Columns.Add(ColumnInbound);

        }

        private void ProgressTimer_Tick(object sender, EventArgs e)
        {
            SpkProgBar.Value = VaxSIPUserAgentOCX.GetSpkSoundLevel();
            MicProgBar.Value = VaxSIPUserAgentOCX.GetMicSoundLevel();
        }
    }
}